unit DrBobPro;
interface
uses
  Classes, Provider;

type
  TBDataSetProvider = class(TDataSetProvider)
  public
    constructor Create(AOwner: TComponent); override;
    function InternalGetRecords(Count: Integer; out RecsOut: Integer;
      Options: TGetRecordOptions; const CommandText: WideString;
      var Params: OleVariant): OleVariant; override;

    procedure CreateDataPacket(PacketOpts: TGetRecordOptions;
      ProvOpts: TProviderOptions; var RecsOut: Integer;
      var Data: OleVariant); override;
  private
    FBytesTransferred: LongInt;
  public
    property BytesTransferred: LongInt read FBytesTransferred;
  end;

  procedure Register;

implementation
uses
  DSIntf, ActiveX;

constructor TBDataSetProvider.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FBytesTransferred := 0
end;

function TBDataSetProvider.InternalGetRecords(Count: Integer;
                           out RecsOut: Integer;
                           Options: TGetRecordOptions;
                           const CommandText: WideString;
                           var Params: OleVariant): OleVariant;
begin
  Result := inherited InternalGetRecords(Count, RecsOut, Options, CommandText, Params);
  if RecsOut > 0 then
    Inc(FBytesTransferred,DataSet.RecordSize * RecsOut);
  writeln(Name,' transferred: ',FBytesTransferred)
end;

procedure TBDataSetProvider.CreateDataPacket(PacketOpts: TGetRecordOptions;
  ProvOpts: TProviderOptions; var RecsOut: Integer; var Data: OleVariant);
begin
  inherited;
  writeln(Name,' RecsOut: ', RecsOut,
    ' with data packet size: ',
    DataPacketSize(tagVariant(Data).PArray))
end;

procedure Register;
begin
  RegisterComponents('DrBob42',[TBDataSetProvider])
end;

end.
